## hotpatch 0.2

=== CMakeLists.txt ===
### hotpatch is a dll injection strategy
### Copyright (c) 2010-2011, Vikas Naresh Kumar, Selective Intellect LLC
### All rights reserved.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
###     * Redistributions of source code must retain the above copyright
###       notice, this list of conditions and the following disclaimer.
### 
###     * Redistributions in binary form must reproduce the above copyright
###       notice, this list of conditions and the following disclaimer in the
###       documentation and/or other materials provided with the distribution.
### 
###     * Neither the name of Selective Intellect LLC nor the
###       names of its contributors may be used to endorse or promote products
###       derived from this software without specific prior written permission.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
### ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
### WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
### DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
### DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
### (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
### LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
### ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
### (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
### SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
### 
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

option(DEBUG "In Debug mode" ON)
option(USE_ASM "Use Assembler" OFF)
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	set(DEBUG OFF)
endif (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")

if (CMAKE_COMPILER_IS_GNUCC)
	if (ARCH)
		if (ARCH STREQUAL "x86_64")
			message(STATUS "Compiling for ${ARCH} 64-bit")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
			set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -m64")
		else (ARCH STREQUAL "x86_64")
			message(STATUS "Compiling for ${ARCH} 32-bit")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
			set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -m32")
		endif (ARCH STREQUAL "x86_64")
	endif (ARCH)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fPIC -pedantic -ansi -posix")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -fno-inline")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pedantic -ansi -posix")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -fno-inline")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2")
endif (CMAKE_COMPILER_IS_GNUCC)
include(CTest)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckTypeSize)
if (WIN32 OR APPLE)
	message(FATAL_ERROR "Windows or Mac OSX is not supported")
endif (WIN32 OR APPLE)
check_include_file("features.h" HOTPATCH_HAS_FEATURES_H)
check_include_file("errno.h" HOTPATCH_HAS_ERRNO_H)
check_include_file("stdio.h" HOTPATCH_HAS_STDIO_H)
check_include_file("stdlib.h" HOTPATCH_HAS_STDLIB_H)
check_include_file("string.h" HOTPATCH_HAS_STRING_H)
check_function_exists("strnlen" HOTPATCH_HAS_STRNLEN_FN)
check_function_exists("strtok_r" HOTPATCH_HAS_STRTOKR_FN)
check_include_file("stddef.h" HOTPATCH_HAS_STDDEF_H)
check_include_file("stdint.h" HOTPATCH_HAS_STDINT_H)
check_include_file("stdarg.h" HOTPATCH_HAS_STDARG_H)
check_include_file("stdbool.h" HOTPATCH_HAS_STDBOOL_H)
check_include_file("time.h" HOTPATCH_HAS_TIME_H)
check_include_file("sys/time.h" HOTPATCH_HAS_SYS_TIME_H)
check_include_file("sys/types.h" HOTPATCH_HAS_SYS_TYPES_H)
check_include_file("unistd.h" HOTPATCH_HAS_UNISTD_H)
check_include_file("assert.h" HOTPATCH_HAS_ASSERT_H)
check_include_file("limits.h" HOTPATCH_HAS_LIMITS_H)
if (UNIX AND ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	check_include_file("elf.h" HOTPATCH_HAS_LINUX_ELF_H)
	check_include_file("dlfcn.h" HOTPATCH_HAS_LINUX_DLFCN_H)
	if (HOTPATCH_HAS_LINUX_DLFCN_H)
		set(HOTPATCH_OTHER_LIBS ${HOTPATCH_OTHER_LIBS} dl)
	endif (HOTPATCH_HAS_LINUX_DLFCN_H)
	check_include_file("link.h" HOTPATCH_HAS_LINUX_LINK_H)
	check_include_file("pthread.h" HOTPATCH_HAS_LINUX_PTHREAD_H)
	if (HOTPATCH_HAS_LINUX_PTHREAD_H)
		set(HOTPATCH_OTHER_LIBS ${HOTPATCH_OTHER_LIBS} pthread)
	endif (HOTPATCH_HAS_LINUX_PTHREAD_H)
	check_include_file("setjmp.h" HOTPATCH_HAS_LINUX_SETJMP_H)
	check_include_file("signal.h" HOTPATCH_HAS_LINUX_SIGNAL_H)
	check_include_file("sys/ptrace.h" HOTPATCH_HAS_LINUX_SYS_PTRACE_H)
	check_include_file("sys/wait.h" HOTPATCH_HAS_LINUX_SYS_WAIT_H)
	check_include_file("sys/stat.h" HOTPATCH_HAS_LINUX_SYS_STAT_H)
	check_include_file("fcntl.h" HOTPATCH_HAS_LINUX_FCNTL_H)
	check_include_file("sys/syscall.h" HOTPATCH_HAS_LINUX_SYS_SYSCALL_H)
	check_include_files("sys/types.h;sys/user.h" HOTPATCH_HAS_LINUX_SYS_USER_H)
	check_function_exists("dl_iterate_phdr" HOTPATCH_HAS_LINUX_DLITERPHDR_FN)
	check_type_size("void *" HOTPATCH_VOIDPTR_SIZE) 
	if (NOT HAVE_HOTPATCH_VOIDPTR_SIZE)
		message(FATAL_ERROR "(void *) does not seem to be supported.")
	endif (NOT HAVE_HOTPATCH_VOIDPTR_SIZE)
	## Find assemblers
	if (USE_ASM)
	include(FindPerl)
	find_file(HOTPATCH_NASM nasm)
	if (HOTPATCH_NASM MATCHES "-NOTFOUND")
		message(STATUS "Found nasm - not found")
		set(HOTPATCH_HAS_NASM 0)
	else (HOTPATCH_NASM MATCHES "-NOTFOUND")
		message(STATUS "Found nasm - ${HOTPATCH_NASM}")
		set(HOTPATCH_HAS_NASM 1)
	endif (HOTPATCH_NASM MATCHES "-NOTFOUND")
	find_file(HOTPATCH_YASM yasm)
	if (HOTPATCH_YASM MATCHES "-NOTFOUND")
		message(STATUS "Found yasm - no")
		set(HOTPATCH_HAS_YASM 1)
	else (HOTPATCH_YASM MATCHES "-NOTFOUND")
		message(STATUS "Found yasm - ${HOTPATCH_YASM}")
		set(HOTPATCH_HAS_YASM 1)
	endif (HOTPATCH_YASM MATCHES "-NOTFOUND")
	if (HOTPATCH_HAS_NASM OR HOTPATCH_HAS_YASM)
		if (HOTPATCH_HAS_NASM)
			message(STATUS "Using nasm - yes")
			message(STATUS "Using yasm - no")
			set(HOTPATCH_ASM ${HOTPATCH_NASM} CACHE INTERNAL "" FORCE)
		else (HOTPATCH_HAS_NASM)
			message(STATUS "Using nasm - no")
			message(STATUS "Using yasm - yes")
			set(HOTPATCH_ASM ${HOTPATCH_YASM} CACHE INTERNAL "" FORCE)
		endif (HOTPATCH_HAS_NASM)
	else (HOTPATCH_HAS_NASM OR HOTPATCH_HAS_YASM)
		message(FATAL_ERROR "Unable to find nasm or yasm."
		" Please install nasm or yasm or both and make it available in the"
		" PATH")
	endif (HOTPATCH_HAS_NASM OR HOTPATCH_HAS_YASM)
	set(HOTPATCH_USE_ASM 1)
	endif (USE_ASM)
endif (UNIX AND ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(test)

=== Makefile ===
### hotpatch is a dll injection strategy
### Copyright (c) 2010-2011, Vikas Naresh Kumar, Selective Intellect LLC
### All rights reserved.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
###     * Redistributions of source code must retain the above copyright
###       notice, this list of conditions and the following disclaimer.
### 
###     * Redistributions in binary form must reproduce the above copyright
###       notice, this list of conditions and the following disclaimer in the
###       documentation and/or other materials provided with the distribution.
### 
###     * Neither the name of Selective Intellect LLC nor the
###       names of its contributors may be used to endorse or promote products
###       derived from this software without specific prior written permission.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
### ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
### WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
### DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
### DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
### (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
### LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
### ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
### (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
### SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###
CMAKE=$(shell which cmake)
CTEST=$(shell which ctest)
PREFIX?=/usr
ARCH=$(shell uname -m)

default: release
.PHONY: default

all: release debug
.PHONY: all

clean: cleanrelease
.PHONY: clean

test: testrelease
.PHONY: test

install: installrelease
.PHONY: install

release:
	@mkdir -p Release
	@cd Release && $(CMAKE) -DARCH=$(ARCH) -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=$(PREFIX) ..
	@cd Release && $(MAKE)
	@echo "Release Build complete"
.PHONY: release

debug:
	@mkdir -p Debug
	@cd Debug && $(CMAKE) -DARCH=$(ARCH) -DCMAKE_BUILD_TYPE=Debug -DCMAKE_INSTALL_PREFIX=$(PREFIX) ..
	@cd Debug && $(MAKE)
	@echo "Debug Build complete"
.PHONY: debug

cleanrelease:
	@if test -d Release; then cd Release && $(MAKE) clean; fi
	@if test -d Release; then cd Release && rm -f CMakeCache.txt; fi
	@if test -d Release; then echo "Release Cleaning complete"; else echo "Nothing to clean"; fi
.PHONY: cleanrelease

cleandebug:
	@if test -d Debug; then cd Debug && $(MAKE) clean; fi
	@if test -d Debug; then cd Debug && rm -f CMakeCache.txt; fi
	@if test -d Debug; then echo "Debug Cleaning complete"; else echo "Nothing to clean"; fi
.PHONY: cleandebug

testrelease: release
	cd Release && $(CTEST)
.PHONY: testrelease

testdebug: debug
	cd Debug && $(CTEST)
.PHONY: testdebug

installrelease: release
	@cd Release && $(CMAKE) -DARCH=$(ARCH) -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=$(PREFIX) ..
	@cd Release && $(MAKE) install
	@echo "Release installation complete"
.PHONY: installrelease

installdebug: debug
	@cd Debug && $(CMAKE) -DARCH=$(ARCH) -DCMAKE_BUILD_TYPE=Debug -DCMAKE_INSTALL_PREFIX=$(PREFIX) ..
	@cd Debug && $(MAKE) install
	@echo "Debug installation complete"
.PHONY: installdebug

=== src/CMakeLists.txt ===
### hotpatch is a dll injection strategy
### Copyright (c) 2010-2011, Vikas Naresh Kumar, Selective Intellect LLC
### All rights reserved.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
###     * Redistributions of source code must retain the above copyright
###       notice, this list of conditions and the following disclaimer.
### 
###     * Redistributions in binary form must reproduce the above copyright
###       notice, this list of conditions and the following disclaimer in the
###       documentation and/or other materials provided with the distribution.
### 
###     * Neither the name of Selective Intellect LLC nor the
###       names of its contributors may be used to endorse or promote products
###       derived from this software without specific prior written permission.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
### ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
### WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
### DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
### DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
### (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
### LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
### ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
### (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
### SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
### 
project(hotpatch)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if (USE_ASM)
foreach (ASM_VAR call32 call64)
	set(ASM_F ${CMAKE_CURRENT_SOURCE_DIR}/${ASM_VAR}.s)
	set(ASM_F_OBJ ${CMAKE_CURRENT_BINARY_DIR}/${ASM_VAR}.o)
	set(ASM_F_HDR ${CMAKE_CURRENT_BINARY_DIR}/${ASM_VAR}.h)
	set(ASM_F_VAR hotpatch_${ASM_VAR})
	set(ASM2HDR ${CMAKE_CURRENT_SOURCE_DIR}/asm2hdr.pl)
	if (HOTPATCH_ASM AND PERL_FOUND)
		add_custom_command(OUTPUT ${ASM_F_HDR}
			COMMAND ${HOTPATCH_ASM} ARGS ${ASM_F} -o ${ASM_F_OBJ}
			COMMAND ${PERL_EXECUTABLE} ARGS ${ASM2HDR} ${ASM_F_OBJ}
			${ASM_F_HDR} ${ASM_F_VAR}
			DEPENDS ${ASM_F} ${ASM2HDR}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
		set(ASM_HEADERS ${ASM_HEADERS} ${ASM_F_HDR})
	else (HOTPATCH_ASM AND PERL_FOUND)
		message(FATAL_ERROR "You need Perl for this")
	endif (HOTPATCH_ASM AND PERL_FOUND)
endforeach (ASM_VAR call32 call64)
add_custom_target(asm_header DEPENDS ${ASM_HEADERS})
endif (USE_ASM)

add_library(hotpatch SHARED hotpatch.c exedetails.c loader.c)
add_library(hotpatch_s STATIC hotpatch.c exedetails.c loader.c)
if (USE_ASM)
	add_dependencies(hotpatch asm_header)
	add_dependencies(hotpatch_s asm_header)
endif (USE_ASM)
set_target_properties(hotpatch_s PROPERTIES OUTPUT_NAME "hotpatch"
	CLEAN_DIRECT_OUTPUT 1)
set_target_properties(hotpatch PROPERTIES CLEAN_DIRECT_OUTPUT 1)
install(TARGETS hotpatch LIBRARY DESTINATION lib)
install(TARGETS hotpatch_s ARCHIVE DESTINATION lib)

add_executable(hotpatcher main.c)
target_link_libraries(hotpatcher hotpatch_s)
install(TARGETS hotpatcher RUNTIME DESTINATION bin)

=== debian/changelog ===
hotpatch (0.2-1kali4) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Update standards version to 4.5.1, no changes needed.
  * Update standards version to 4.6.1, no changes needed.
  [ Ben Wilson ]
  * Add Uploaders
  * Remove template comment and switch spaces to tabs
  [ Steev Klimaszewski ]
  * Add d/watch file pointing to git.
  * Add lintian override for lack of ldconfig trigger.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Fri, 06 Jan 2023 12:24:29 -0600

hotpatch (0.2-1kali3) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Raphaël Hertzog ]
  * Restrict builds to amd64 and i386

 -- Raphaël Hertzog <raphael@offensive-security.com>  Tue, 08 Jun 2021 16:26:28 +0200

hotpatch (0.2-1kali2) kali-dev; urgency=medium

  [ Raphaël Hertzog ]
  * Update Maintainer field
  * Update Vcs-* fields for the move to gitlab.com
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file

  [ Sophie Brun ]
  * Bump Standards-Version and use debhelper-compat 13
  * Run the tests during the build

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 10 Dec 2020 09:24:30 +0100

hotpatch (0.2-1kali1) kali; urgency=low

  * Edited rules to skip auto_test

 -- Devon Kearns <dookie@kali.org>  Tue, 15 Jan 2013 15:38:01 -0700

hotpatch (0.2-1kali0) kali; urgency=low

  * Initial release

 -- Devon Kearns <dookie@kali.org>  Tue, 15 Jan 2013 15:04:57 -0700

=== debian/control ===
Source: hotpatch
Section: utils
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Devon Kearns <dookie@kali.org>,
           Sophie Brun <sophie@offensive-security.com>,
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.6.1
Homepage: https://github.com/vikasnkumar/hotpatch
Vcs-Git: https://gitlab.com/kalilinux/packages/hotpatch.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/hotpatch

Package: hotpatch
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Hot patches Linux executables with .so file injection
 Hotpatch is a library that can be used to dynamically load a
 shared library (.so) file on Linux from one process into
 another already running process, without affecting the
 execution of the target process. The API is a C API, but
 also supported in C++.

=== debian/watch ===
version=4
opts="mode=git, pretty=0.2~git%cd, pgpmode=none" \
  https://github.com/vikasnkumar/hotpatch.git HEAD
# Upstream does not tag releases, additionally, it has been 9 years
# since the last time the *code* was touched.
#opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/hotpatch-$1\.tar\.gz/ \
#  https://github.com/vikasnkumar/hotpatch/tags .*/v?(\d\S*)\.tar\.gz

## hotpatch 0.2+git20200110.1.fd2baf1

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,8 @@
 
 option(DEBUG "In Debug mode" ON)
 option(USE_ASM "Use Assembler" OFF)
+option(BUILD_HOTPATCHER "Build hotpatcher" ON)
+option(BUILD_TESTS "Build tests" ON)
 if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
 	set(DEBUG OFF)
 endif (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
@@ -146,4 +148,6 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
 add_subdirectory(include)
 add_subdirectory(src)
-add_subdirectory(test)
+if (BUILD_TESTS)
+	add_subdirectory(test)
+endif (BUILD_TESTS)

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 ###
 CMAKE=$(shell which cmake)
 CTEST=$(shell which ctest)
-PREFIX?=/usr
+PREFIX?=/usr/local
 ARCH=$(shell uname -m)
 
 default: release

=== include/CMakeLists.txt ===
### hotpatch is a dll injection strategy
### Copyright (c) 2010-2011, Vikas Naresh Kumar, Selective Intellect LLC
### All rights reserved.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
###     * Redistributions of source code must retain the above copyright
###       notice, this list of conditions and the following disclaimer.
### 
###     * Redistributions in binary form must reproduce the above copyright
###       notice, this list of conditions and the following disclaimer in the
###       documentation and/or other materials provided with the distribution.
### 
###     * Neither the name of Selective Intellect LLC nor the
###       names of its contributors may be used to endorse or promote products
###       derived from this software without specific prior written permission.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
### ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
### WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
### DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
### DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
### (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
### LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
### ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
### (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
### SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
### 
configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/hotpatch_config.h @ONLY)
install(FILES hotpatch.h DESTINATION include)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,8 @@
 install(TARGETS hotpatch LIBRARY DESTINATION lib)
 install(TARGETS hotpatch_s ARCHIVE DESTINATION lib)
 
-add_executable(hotpatcher main.c)
-target_link_libraries(hotpatcher hotpatch_s)
-install(TARGETS hotpatcher RUNTIME DESTINATION bin)
+if (BUILD_HOTPATCHER)
+	add_executable(hotpatcher main.c)
+	target_link_libraries(hotpatcher hotpatch_s)
+	install(TARGETS hotpatcher RUNTIME DESTINATION bin)
+endif (BUILD_HOTPATCHER)

=== test/CMakeLists.txt ===
### hotpatch is a dll injection strategy
### Copyright (c) 2010-2011, Vikas Naresh Kumar, Selective Intellect LLC
### All rights reserved.
### 
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
### 
###     * Redistributions of source code must retain the above copyright
###       notice, this list of conditions and the following disclaimer.
### 
###     * Redistributions in binary form must reproduce the above copyright
###       notice, this list of conditions and the following disclaimer in the
###       documentation and/or other materials provided with the distribution.
### 
###     * Neither the name of Selective Intellect LLC nor the
###       names of its contributors may be used to endorse or promote products
###       derived from this software without specific prior written permission.
### 
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
### ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
### WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
### DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
### DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
### (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
### LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
### ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
### (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
### SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
### 
project(unit_tests)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if (ARCH STREQUAL "x86_64")
add_executable(ptracetest ptrace.c)
endif (ARCH STREQUAL "x86_64")

add_executable(dummy dummy.c)
add_executable(loadertest loader.c)
target_link_libraries(loadertest hotpatch)
add_test(loadertest ${CMAKE_CURRENT_BINARY_DIR}/loadertest)

add_executable(compiletestcpp cpptest.cpp)
target_link_libraries(compiletestcpp hotpatch)
add_test(compiletestcpp ${CMAKE_CURRENT_BINARY_DIR}/compiletestcpp)

add_executable(compiletestc ctest.c)
target_link_libraries(compiletestc hotpatch)
add_test(compiletestc ${CMAKE_CURRENT_BINARY_DIR}/compiletestc)

add_library(hotpatchtest SHARED dlltest.c)
set_target_properties(hotpatchtest PROPERTIES LINK_FLAGS "-fPIC -nostartfiles")
install(TARGETS hotpatchtest LIBRARY DESTINATION lib)

=== debian/changelog ===
hotpatch (0.2+git20200110.1.fd2baf1-0kali1~jan+nus10) kali-bleeding-edge; urgency=low

  * New upstream snapshot.
  * Build for debian-janitor apt repository.

 -- Kali Janitor <janitor@kali.org>  Wed, 13 Apr 2022 06:42:03 -0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Devon Kearns <dookie@kali.org>,
            Sophie Brun <sophie@offensive-security.com>,
 Build-Depends: debhelper-compat (= 13), cmake
-Standards-Version: 4.6.1
+Standards-Version: 4.5.1
 Homepage: https://github.com/vikasnkumar/hotpatch
 Vcs-Git: https://gitlab.com/kalilinux/packages/hotpatch.git
 Vcs-Browser: https://gitlab.com/kalilinux/packages/hotpatch

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_build:
	cmake .
	$(MAKE)

override_dh_auto_install:
	install include/hotpatch.h $(CURDIR)/debian/hotpatch/usr/include/
	install src/libhotpatch.so $(CURDIR)/debian/hotpatch/usr/lib/
	install src/libhotpatch.a $(CURDIR)/debian/hotpatch/usr/lib/
	install src/hotpatcher $(CURDIR)/debian/hotpatch/usr/bin/
	install test/libhotpatchtest.so $(CURDIR)/debian/hotpatch/usr/lib/
